chiark / gitweb /
init/tripe-init.in, contrib/tripe-upstart.in: Reformat startup rune.
[tripe] / init / tripe-init.in
CommitLineData
0fa31a96 1#! /bin/sh
4ce4c726
MW
2###
3### tripe init script
4### suitable for direct use in most SysV-style inits
5
6### BEGIN INIT INFO
7# Provides: tripe
8# Required-Start: $local_fs $remote_fs $named $network
9# Required-Stop: $local_fs $remote_fs $network
10# Default-Start: 2 3 4 5
11# Default-Stop: 0 1 6
12# Short-Description: tripe Virtual Private Network server
13### END INIT INFO
0fa31a96 14
0fa31a96 15set -e
16
4ce4c726
MW
17###--------------------------------------------------------------------------
18### Configuration.
0fa31a96 19
ef4a1ab7 20[ -f @initconfig@ ] && . @initconfig@
4ce4c726 21
ef4a1ab7 22: ${prefix=@prefix@} ${exec_prefix=@exec_prefix@}
23: ${bindir=@bindir@} ${sbindir=@sbindir@}
797cf76b 24: ${TRIPEDIR=@configdir@} ${TRIPESOCK=@socketdir@/tripesock}
3cdc3f3a 25: ${pidfile=@pidfile@}
ef4a1ab7 26: ${tripe=$sbindir/tripe} ${tripectl=$bindir/tripectl}
4ce4c726 27
0fa31a96 28PATH=/usr/bin:/usr/sbin:/bin:/sbin:$bindir
4ce4c726 29export PATH TRIPEDIR TRIPESOCK TRIPE_SLIPIF
ef4a1ab7 30
4ce4c726
MW
31###--------------------------------------------------------------------------
32### Pre-flight checks.
3cdc3f3a 33
4ce4c726
MW
34## Give up if there's no binary.
35if test ! -x "$tripe" || test ! -x "$tripectl"; then
36 echo >&2 "Not starting/stopping TrIPE: binary files missing"
37 exit 0
38fi
39
40## Give up if there's no key.
41if test ! -f "$TRIPEDIR/keyring" || test ! -f "$TRIPEDIR/keyring.pub"; then
3cdc3f3a 42 echo >&2 "Not starting/stopping TrIPE: keyring files missing"
43 exit 0
44fi
45
4ce4c726
MW
46## Check it will work, or at least stands a fighting chance.
47##
48## (Having loads of different tunnel types doesn't help any.)
49case ${tunnel-`$tripe --tunnels | head -1`},`uname -s` in
50
51 ## Linux TUN/TAP.
52 linux,Linux)
53 if { test -f /proc/misc && grep -q tun /proc/misc; } ||
54 modprobe -q tun; then
55 : good
56 else
57 echo >&2 "$tripe needs the Linux TUN/TAP driver to run."
58 exit 1
59 fi
60 if test -c /dev/net/tun; then
61 : good
62 else
63 echo >&2 "$tripe needs /dev/net/tun, which is missing."
64 exit 1
65 fi
ef4a1ab7 66 ;;
4ce4c726
MW
67
68 ## Linux Unet (obsolete).
69 unet,Linux)
70 if { test -f /proc/devices && grep -q unet /proc/devices; } ||
71 modprobe -q unet; then
72 : good
73 else
74 echo >&2 "$tripe needs the Linux UNET driver to run."
75 exit 1
76 fi
77 if test -c /dev/unet; then
78 : good
79 else
80 echo >&2 "$tripe needs /dev/unet, which is missing."
81 exit 1
82 fi
ef4a1ab7 83 ;;
4ce4c726
MW
84
85 ## BSD tun.
86 bsd,*BSD)
87 ## Don't know how to check the device is working. Check the device file
88 ## exists and hope for the best.
89 if test -c /dev/tun0; then
90 : good
91 else
92 echo >&2 "$tripe needs /dev/tun0, which is missing."
93 exit 1
94 fi
ef4a1ab7 95 ;;
4ce4c726
MW
96
97 ## SLIP.
98 slip,*)
b9066fbb 99 if test "$TRIPE_SLIPIF" = ""; then
100 echo >&2 "$tripe needs SLIP interfaces set up!"
101 exit 1
102 fi
103 ;;
4ce4c726
MW
104
105 ## Various kinds of misconfiguration.
106 linux,* | unet,*)
107 echo >&2 "CONFIGURATION ERROR"
108 echo >&2 " $tripe is compiled to use a Linux tunnel device, but"
109 echo >&2 " this system is `uname -s`"
110 exit 1
111 ;;
112 bsd,*)
113 echo >&2 "CONFIGURATION ERROR"
114 echo >&2 " $tripe is compiled to use a BSD tunnel device, but"
115 echo >&2 " this system is `uname -s`"
116 exit 1
117 ;;
ef4a1ab7 118esac
e04c2d50 119
4ce4c726
MW
120###--------------------------------------------------------------------------
121### Do what was wanted.
0fa31a96 122
123case "$1" in
4ce4c726 124
0fa31a96 125 start)
126 echo -n "Starting TrIPE VPN daemon:"
4ce4c726
MW
127
128 ## Check to see whether the daemon is already going. If it can respond
129 ## to a simple request, we'll assume that it is.
3cdc3f3a 130 if $tripectl version >/dev/null 2>/dev/null; then
0fa31a96 131 echo " already running"
132 exit 0
133 fi
4ce4c726
MW
134
135 ## Start the server, passing lots of arguments.
ef4a1ab7 136 $tripectl -D -s -p$tripe \
3cdc3f3a 137 -P$pidfile \
85b239ad
MW
138 -f${logfile-@logfile@} \
139 ${keytag+-S-t$keytag} \
140 ${addr+-S-b$addr} ${port+-S-p$port} \
141 ${user+-U$user} ${group+-G$group} \
142 ${sockmode+-S-m$sockmode} \
143 ${trace+-S-T$trace} \
144 ${tunnel+-S-n$tunnel} \
145 $miscopts
4ce4c726
MW
146
147 ## Wait for the server to start up. This doesn't usually take long.
0fa31a96 148 for i in 1 2 3 4 give-up; do
149 $tripectl help >/dev/null 2>/dev/null && break
150 sleep 1
151 done
4ce4c726 152
0fa31a96 153 if [ $i = give-up ]; then
154 echo " wouldn't start"
155 exit 1
156 fi
4ce4c726 157
0fa31a96 158 echo -n " tripe"
4ce4c726
MW
159
160 ## Start up the ancillary services.
a62f8e8a
MW
161 sep=" services [" end=""
162 [ -d $TRIPEDIR/services ] && for i in $TRIPEDIR/services/*; do
163 [ -x $i ] || continue
164 name=`basename $i`
165 case $name in *~|\#*) continue;; esac
166 if $i --daemon --startup; then
167 echo -n "$sep$name"
168 else
a571143b 169 echo -n "$sep($name failed)"
a62f8e8a
MW
170 fi
171 sep=" " end="]"
172 done
173 echo -n "$end"
4ce4c726
MW
174
175 ## Start up the statically configured peers.
a62f8e8a
MW
176 sep=" peers [" end=""
177 [ -d $TRIPEDIR/peers ] && for i in $TRIPEDIR/peers/*; do
595935b7 178 [ -x $i ] || continue
0fa31a96 179 name=`basename $i`
595935b7 180 case $name in *~|\#*) continue;; esac
e04c2d50 181 if $i; then
a62f8e8a 182 echo -n "$sep$name"
595935b7 183 else
a571143b 184 echo -n "$sep($name failed)"
595935b7 185 fi
a62f8e8a 186 sep=" " end="]"
0fa31a96 187 done
4ce4c726
MW
188
189 ## Happy.
a62f8e8a 190 echo "$end done"
0fa31a96 191 ;;
4ce4c726 192
0fa31a96 193 stop)
194 echo -n "Stopping TrIPE VPN daemon:"
4ce4c726
MW
195
196 ## If there's no socket, it must have quit (probably nonviolently).
6c3803c4 197 if (cd $TRIPEDIR && test ! -S $TRIPESOCK); then
3cdc3f3a 198 echo " not running"
4ce4c726
MW
199
200 ## Ask it to die nicely.
3cdc3f3a 201 elif $tripectl quit >/dev/null 2>&1; then
202 echo " done"
4ce4c726
MW
203
204 ## If there's no pidfile then tripectl presumably deleted it.
3cdc3f3a 205 elif test ! -f $pidfile; then
206 echo " stale socket found: removing"
797cf76b 207 rm -f $TRIPESOCK
4ce4c726
MW
208
209 ## Otherwise kill the process unpleasantly.
3cdc3f3a 210 elif kill `cat $pidfile`; then
211 echo " done (killed violently)"
212 else
819018a9 213 echo " it doesn't want to die!"
3cdc3f3a 214 exit 1
215 fi
0fa31a96 216 ;;
4ce4c726 217
ef4a1ab7 218 status)
219 for i in `$tripectl list`; do
220 echo "Peer \`$i':"
221 $tripectl stats $i | sed 's/^/ /'
222 done
223 ;;
4ce4c726 224
de014da6 225 reload)
226 $tripectl reload
227 echo "Keyrings reloaded OK."
228 ;;
4ce4c726 229
0fa31a96 230 restart | force-reload)
231 sh $0 stop
232 sh $0 start
233 ;;
4ce4c726 234
0fa31a96 235 *)
de014da6 236 echo >&2 "usage: $0 start|stop|restart|status|reload|force-reload"
0fa31a96 237 exit 1
238 ;;
4ce4c726 239
0fa31a96 240esac
4ce4c726
MW
241
242###----- That's all, folks --------------------------------------------------